#include <cstdio>
#include <iostream>
#include <vector>
using namespace std;

int rot_val(char x)
{
    if(x=='R')return +1;
    if(x=='L')return -1;
    if(x=='Q')return +2;
    return 0;
}

int hflip_val(char x){return (x=='H')?1:0;}

int vflip_val(char x){return (x=='V')?1:0;}

bool is_rot(char x){return x!='H' && x!='V';}

int n, t, m;
vector<vector<bool>> table;
vector<vector<bool>> rotated;

void read()
{
    cin>>n>>t>>m;
    table.resize(n+1, vector<bool>(n+1, false));
    for(int i=0;i<t;i++)
    {
        int x, y;
        cin>>x>>y;
        table[x][y] = true;
    }
}

void do_rots(int rot)
{
    //printf("doing rots %d ", rot);
    rot = rot%4;
    if(rot<0) rot = 4+rot;
    //printf("de facto %d\n", rot);
    if(rot==0)return;

    for(int r=0;r<rot;r++)
    {
        for(int i=1;i<=n;i++)for(int j=1;j<=n;j++)rotated[i][j]=table[i][j];

        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                rotated[i][j]=table[n-j+1][i];
            }
        }

        for(int i=1;i<=n;i++)for(int j=1;j<=n;j++)table[i][j]=rotated[i][j];
    }
}

void do_flips(int h, int v)
{
    //printf("doing flips %d %d\n", h, v);
    h=h%2;
    v=v%2;

    if(h!=0)
    {
        for(int i=1;i<=n;i++)
        {
            for(int j=1, k=n;j<k;j++, k--)swap(table[i][j], table[i][k]);
        }
    }
    if(v!=0)
    {
        for(int i=1;i<=n;i++)
        {
            for(int j=1, k=n;j<k;j++, k--)swap(table[j][i], table[k][i]);
        }
    }
}

void print_table()
{

    for(int i=1;i<=n;i++)
    {
        printf("   ");
        for(int j=1;j<=n;j++)
        {
            printf("%d ", (int)table[i][j]);
        }
        putchar('\n');
    }
}

void solve()
{
    rotated.resize(n+1, vector<bool>(n+1));
    //print_table();
    int hFlip=0, vFlip=0, rot=0;
    for(int i=0;i<m;i++)
    {
        int type;
        cin>>type;

        if(type==1)
        {
            string command;
            cin>>command;
            char c = command[0];

            if(is_rot(c) && hFlip+vFlip != 0)
            {
                do_flips(hFlip, vFlip);
                hFlip=vFlip=0;
            }
            else if(!is_rot(c) && rot!=0)
            {
                do_rots(rot);
                rot = 0;
            }

            rot+=rot_val(command[0]);
            hFlip+=hflip_val(command[0]);
            vFlip+=vflip_val(command[0]);

            //printf("vals: %d %d %d\n", rot, hFlip, vFlip);
            //print_table();
        }
        else
        {
            int x, y;
            cin>>x>>y;
            do_rots(rot);
            do_flips(hFlip, vFlip);
            rot=hFlip=vFlip=0;

            table[x][y] = !table[x][y];

            //print_table();
        }
    }

    do_rots(rot);
    do_flips(hFlip, vFlip);
    //print_table();

    int k;
    cin>>k;
    for(int i=1;i<=n&&k!=0;i++)
    {
        for(int j=1;j<=n&&k!=0;j++)
        {
            if(table[i][j])
            {
                printf("%d %d\n", i, j);
                k--;
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
}
/**
3 3 6
1 1
3 2
3 3
1 R
1 H
2 2 1
1 V
2 1 3
1 H
2
**/
