#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;
const int MAXN=170005;
struct point{
    long long x,y;
    int orig;
}plant[MAXN],protein[MAXN];
bool operator==(point a,point b){
    return (a.x==b.x)&&(a.y==b.y);
}
long long orient(point a,point b,point c){
    b.x-=a.x;
    c.x-=a.x;
    b.y-=a.y;
    c.y-=a.y;
    return b.x*c.y-b.y*c.x;
}
point selectPr,selectPl;
bool cmp(point a,point b){
    bool val1=orient(selectPl,selectPr,a)>0;
    bool val2=orient(selectPl,selectPr,b)>0;
    if(val1==val2){
        return orient(a,selectPr,b)>0;
    }
    return val1;
}
bool intersect(point a,point b,point c,point d){
    if(a==b||a==c||a==d||b==c||b==d||c==d) return false;
    bool val1=orient(a,c,b)>0;
    bool val2=orient(a,d,b)>0;
    bool val3=orient(c,a,d)>0;
    bool val4=orient(c,b,d)>0;
    if(val1!=val2&&val3!=val4){
        return true;
    }
    return false;
}
int main(){
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    int n;
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>protein[i].x>>protein[i].y;
        protein[i].orig=i+1;
    }
    for(int i=0;i<n;i++){
        cin>>plant[i].x>>plant[i].y;
        plant[i].orig=i+1+n;
    }
    selectPr=protein[0];
    selectPl=plant[0];
    sort(plant+1,plant+n,cmp);
    sort(protein+1,protein+n,cmp);
    /*for(int i=0;i<n;i++){
        cout<<protein[i].orig<<" ";
    }
    cout<<"\n";
    for(int j=0;j<n;j++){
        cout<<plant[j].orig<<" ";
    }
    cout<<"\n";*/
    cout<<2*n-1<<"\n";
    vector<pair<point,point>> ans;
    for(int i=0;i<n;i++){
        cout<<"1 "<<n+i+1<<"\n";
        ans.push_back({protein[0],plant[i]});
    }
    int cnt=1;
    for(int i=0;i<n;i++){
        while(cnt<n&&(i==n-1||cmp(protein[cnt],plant[(i+1)%n]))){
            cout<<protein[cnt].orig<<" ";
            if(orient(plant[i],protein[0],plant[(i+1)%n])>0){
                cout<<plant[i].orig<<"\n";
            }else{
                if(orient(plant[0],protein[0],protein[cnt])>0){
                    cout<<plant[i].orig<<"\n";
                }else{
                    cout<<plant[(i+1)%n].orig<<"\n";
                }
            }
            cnt++;
        }
    }
    /*for(int i=0;i<ans.size();i++){
        for(int j=0;j<ans.size();j++){
            if(i!=j){
                if(intersect(ans[i].first,ans[i].second,ans[j].first,ans[j].second)){
                    cout<<"ALERT "<<ans[i].first.orig<<" "<<ans[i].second.orig<<" "<<ans[j].first.orig<<" "<<ans[j].second.orig<<"\n";
                    j=ans.size();
                    i=ans.size();
                    //cout
                    //<<ans[i].first<<" "<<ans[i].second<<" "<<ans[j].first<<" "<<ans[j].second<<"\n";
                }
            }
        }
    }*/
    return 0;
}
