#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
using namespace std;

int N, K;

vector < pair < int, int > > coords;
vector < int > arr;
vector < int > path;


map < vector < int >, vector < int > > sPath;
map < vector < int >, vector < int > > trans;

void print( vector < int > &crr ) {
    for ( int i = 0 ; i < 9 ; i ++ ) {
        cout << crr[i] << " ";
        if ( (i+1)%3 == 0 ) { cout << "\n"; }
    }
}

void printP( vector < int > cp ) {
    for ( int i = 0 ; i < cp.size() ; i ++ ) {
        if ( cp[i] == 0 ) { cout << "L"; }
        if ( cp[i] == 1 ) { cout << "R"; }
        if ( cp[i] == 2 ) { cout << "Q"; }
        if ( cp[i] == 3 ) { cout << "V"; }
        if ( cp[i] == 4 ) { cout << "H"; }
    }
}

pair < int, int > ROp( pair < int, int > c ) {
    return make_pair( c.second, N-1-c.first );
}
pair < int, int > LOp( pair < int, int > c ) {
    return ROp( ROp ( ROp ( c ) ) );
}
pair < int, int > QOp( pair < int, int > c ) {
    return ROp( ROp (c) );
}
pair < int, int > HOp ( pair < int, int > c ) {
    return make_pair( c.first, N-1-c.second );
}
pair < int, int > VOp ( pair < int, int > c ) {
    return make_pair( N-1-c.first, c.second );
}


pair < int, int > LRev( pair < int, int > c ) {
    return ROp(c);
}
pair < int, int > RRev( pair < int, int > c ) {
    return LOp(c);
}
pair < int, int > QRev( pair < int, int > c ) {
    return QOp(c);
}
pair < int, int > HRev ( pair < int, int > c ) {
    return HOp(c);
}
pair < int, int > VRev ( pair < int, int > c ) {
    return VOp(c);
}

pair < int, int > revCoords ( pair < int, int > c ) {
    if ( path.size() == 0 ) { return c; }

    for ( int i = path.size()-1 ; i >= 0 ; i -- ) {
        if ( path[i] == 0 ) { c = LRev(c); }
        if ( path[i] == 1 ) { c = RRev(c); }
        if ( path[i] == 2 ) { c = QRev(c); }
        if ( path[i] == 3 ) { c = VRev(c); }
        if ( path[i] == 4 ) { c = HRev(c); }

//        cout << "goes to " << c.first << " " << c.second << "\n";

    }
    return c;
}

pair < int, int > stCoords ( pair < int, int > c ) {
    if ( path.size() == 0 ) { return c; }

    for ( int i = 0 ; i < path.size() ; i ++ ) {
        if ( path[i] == 0 ) { c = LOp(c); }
        if ( path[i] == 1 ) { c = ROp(c); }
        if ( path[i] == 2 ) { c = QOp(c); }
        if ( path[i] == 3 ) { c = VOp(c); }
        if ( path[i] == 4 ) { c = HOp(c); }
    }
    return c;
}



void L( vector < int > &crr ) {
    int p[3][3], q[3][3];
    for ( int i = 0 ; i < 9 ; i ++ ) { p[i/3][i%3] = crr[i]; }

    for ( int y = 0 ; y < 3 ; y ++ ) {
        for ( int x = 0 ; x < 3 ; x ++ ) {
            q[y][x] = p[x][2-y];
        }
    }

    for ( int i = 0 ; i < 9 ; i ++ ) {
        crr[i] = q[i/3][i%3];
    }
}
void R ( vector < int > &crr ) {
    L( crr );
    L( crr );
    L( crr );
}
void Q ( vector < int > &crr ) {
    L( crr );
    L( crr );
}
void V ( vector < int > &crr ) {
    for ( int y = 0 ; y < 1 ; y ++ ) {
        for ( int x = 0 ; x < 3 ; x ++ ) {
            swap( crr[ y*3+x ], crr[ (2-y)*3+x ] );
        }
    }
}
void H ( vector < int > &crr ) {
    for ( int y = 0 ; y < 3 ; y ++ ) {
        for ( int x = 0 ; x < 1 ; x ++ ) {
            swap( crr[ y*3+x ], crr[ y*3+(2-x) ] );
        }
    }
}

void dfs ( vector < int > &cc, int d ) {

    if ( d == 4 ) { return ; }

    if ( sPath.count( cc ) == 0 ) { sPath[cc] = path; }
    else if ( sPath[cc].size() > path.size() ) { sPath[cc] = path; }


    path.push_back( 0 );
    L( cc );
    dfs ( cc, d+1 );
    R( cc );
    path.pop_back();

    path.push_back( 1 );
    R( cc );
    dfs ( cc, d+1 );
    L( cc );
    path.pop_back();

    path.push_back( 2 );
    Q( cc );
    dfs ( cc, d+1 );
    Q( cc );
    path.pop_back();

    path.push_back( 3 );
    V( cc );
    dfs ( cc, d+1 );
    V( cc );
    path.pop_back();

    path.push_back( 4 );
    H( cc );
    dfs ( cc, d+1 );
    H( cc );
    path.pop_back();

}
void dfs2 ( vector < int > &cc, int d ) {

    if ( d == 4 ) { return ; }

    if ( sPath.count( cc ) == 0 ) { sPath[cc] = path; }
    else if ( sPath[cc].size() > path.size() ) { sPath[cc] = path; }

    trans[ path ] = sPath[ cc ];

 //   printP( path );
 //   cout << "  = ";
//    printP( sPath[ cc ] );
//    cout << "\n";


    path.push_back( 0 );
    L( cc );
    dfs2 ( cc, d+1 );
    R( cc );
    path.pop_back();

    path.push_back( 1 );
    R( cc );
    dfs2 ( cc, d+1 );
    L( cc );
    path.pop_back();

    path.push_back( 2 );
    Q( cc );
    dfs2 ( cc, d+1 );
    Q( cc );
    path.pop_back();

    path.push_back( 3 );
    V( cc );
    dfs2 ( cc, d+1 );
    V( cc );
    path.pop_back();

    path.push_back( 4 );
    H( cc );
    dfs2 ( cc, d+1 );
    H( cc );
    path.pop_back();

}
int toOp( char c ) {
    if ( c == 'L' ) { return 0; }
    if ( c == 'R' ) { return 1; }
    if ( c == 'Q' ) { return 2; }
    if ( c == 'V' ) { return 3; }
    if ( c == 'H' ) { return 4; }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    for ( int i = 0 ; i < 9 ; i ++ ) {
        arr.push_back( i );
    }

    //print( arr );
    //cout << "\n";
    H( arr );
  //  print( arr );
    dfs( arr, 0 );
    dfs2( arr, 0 );

    arr.clear();

    int t, m;
    cin >> N >> t >> m;
    for ( int i = 0 ; i < t ; i ++ ) {
        int y, x;
        cin >> y >> x;
        y --;
        x --;
        coords.push_back( make_pair( y, x ) );
    }


    for ( int i = 0 ; i < coords.size() ; ) {
        int j = i;
        for ( ; j < coords.size() && coords[i] == coords[j] ; j ++ ) {}

     //   cout << coords[i].first << " " << coords[i].second << " -> " << (j-i) << "\n";

        i = j;

    }
  //  cout << "first T\n";

    for ( int i = 0 ; i < m ; i ++ ) {
      //  printP(path);
      //  cout << "\n";

        int t;
        cin >> t;
        if ( t == 1 ) {
            char c;
            cin >> c;
            path.push_back( toOp(c) );
            path = trans[ path ];
        }else {
            pair < int, int > a;
            cin >> a.first >> a.second;
            a.first --;
            a.second --;
            a = revCoords(a);

//            cout << "to Coord " << a.first << " " << a.second << "\n";

            coords.push_back( a );
        }
    }

    for ( int i = 0 ; i < coords.size() ; i ++ ) {
        coords[i] = stCoords( coords[i] );
    }
    sort( coords.begin(), coords.end() );
    cin >> K;
    int pr = 0;
    for ( int i = 0 ; i < coords.size() ; ) {
        int j = i;
        for ( ; j < coords.size() && coords[i] == coords[j] ; j ++ ) {}

        if ( (j-i)%2 ) {
            cout << coords[i].first+1 << " " << coords[i].second+1 << "\n";
            pr ++;
            if ( pr == K ) {
                return 0;
            }
        }

        i = j;

    }

    return 0;
}
/*
3 3 6
1 1
3 2
3 3
1 R
1 H
2 2 1
1 V
2 1 3
1 H
2
*/
