#include<iostream>
#include<vector>
#include<stack>
#include<queue>
#include<map>
#include<algorithm>
#include<math.h>
using namespace std;

struct Matrix
{
    int a[2][2];
};

Matrix operator*(const Matrix& a, const Matrix& b)
{
    Matrix r;
    r.a[0][0]=a.a[0][0]*b.a[0][0]+a.a[0][1]*b.a[1][0];
    r.a[0][1]=a.a[0][0]*b.a[0][1]+a.a[0][1]*b.a[1][1];
    r.a[1][0]=a.a[1][0]*b.a[0][0]+a.a[1][1]*b.a[1][0];
    r.a[1][1]=a.a[1][0]*b.a[0][1]+a.a[1][1]*b.a[1][1];
    return r;
}

pair<int, int> operator*(const Matrix& a, const pair<int, int>& p)
{
    pair<int, int> r;
    r.first=p.first*a.a[0][0]+p.second*a.a[0][1];
    r.second=p.first*a.a[1][0]+p.second*a.a[1][1];
    return r;
}

map<pair<int, int>, bool> bl;
int n,t,m,r,s,k;
vector<pair<int, int> > ans;

pair<int, int> toNew(pair<int, int> p)
{
    p.first-=(n+1)/2;
    p.second-=(n+1)/2;
    if (p.first<=0 && n%2==0) --p.first;
    if (p.second<=0 && n%2==0) --p.second;
    return p;
}
pair<int, int> toOld(pair<int, int> p)
{
    if (p.first<=0 && n%2==0) ++p.first;
    if (p.second<=0 && n%2==0) ++p.second;
    p.first+=(n+1)/2;
    p.second+=(n+1)/2;
    return p;
}
void input()
{
    cin>>n>>t>>m;
    for (int i=0;i<t;++i)
    {
        cin>>r>>s;
        bl[make_pair(r,s)]=1;
    }
}
void output()
{
    for (int i=0;i<k;++i)
    {
        cout<<ans[i].first<<' '<<ans[i].second<<'\n';
    }
}
Matrix dir,rev;
Matrix mR, mL, mQ, mV, mH;
void init()
{
    dir.a[0][0]=1;
    dir.a[0][1]=0;
    dir.a[1][0]=0;
    dir.a[1][1]=1;

    rev.a[0][0]=1;
    rev.a[0][1]=0;
    rev.a[1][0]=0;
    rev.a[1][1]=1;

    mR.a[0][0]=0;
    mR.a[0][1]=1;
    mR.a[1][0]=-1;
    mR.a[1][1]=0;

    mL.a[0][0]=0;
    mL.a[0][1]=-1;
    mL.a[1][0]=1;
    mL.a[1][1]=0;

    mQ.a[0][0]=-1;
    mQ.a[0][1]=0;
    mQ.a[1][0]=0;
    mQ.a[1][1]=-1;

    mV.a[0][0]=-1;
    mV.a[0][1]=0;
    mV.a[1][0]=0;
    mV.a[1][1]=1;

    mH.a[0][0]=1;
    mH.a[0][1]=0;
    mH.a[1][0]=0;
    mH.a[1][1]=-1;
}
void solve()
{
    int op;
    char c;
    pair<int, int> p;
    for (int i=0;i<m;++i)
    {
        cin>>op;
        if (op==1)
        {
            cin>>c;
            if (c=='R')
            {
                dir=mR*dir;
                rev=rev*mL;
            }
            else if (c=='L')
            {
                dir=mL*dir;
                rev=rev*mR;
            }
            else if (c=='Q')
            {
                dir=mQ*dir;
                rev=rev*mQ;
            }
            else if (c=='V')
            {
                dir=mV*dir;
                rev=rev*mV;
            }
            else if (c=='H')
            {
                dir=mH*dir;
                rev=rev*mH;
            }
            /*cerr<<" : "<<dir.a[0][0]<<' '<<dir.a[0][1]<<endl;
            cerr<<" : "<<dir.a[1][0]<<' '<<dir.a[1][1]<<endl;
            cerr<<"  : "<<rev.a[0][0]<<' '<<rev.a[0][1]<<endl;
            cerr<<"  : "<<rev.a[1][0]<<' '<<rev.a[1][1]<<endl;
            Matrix r=dir*rev;

            cerr<<" : : "<<r.a[0][0]<<' '<<r.a[0][1]<<endl;
            cerr<<" : : "<<r.a[1][0]<<' '<<r.a[1][1]<<endl;*/
        }
        else
        {
            cin>>r>>s;
            p=make_pair(r,s);
            p=toNew(p);
            //cerr<<" "<<p.first<<" "<<p.second<<endl;
            p=rev*p;
            pair<int, int> p2=dir*p;
            p2=toOld(p2);
            //cerr<<"  "<<p2.first<<" "<<p2.second<<endl;
            p=toOld(p);
            //cerr<<"   "<<p.first<<" "<<p.second<<endl;
            if(bl.find(p)==bl.end() || bl[p]==0) bl[p]=1;
            else bl[p]=0;
        }
    }
    for (auto i=bl.begin();i!=bl.end();++i)
    {
        if (i->second==1) ans.push_back(toOld(dir*toNew(i->first)));
    }
    sort(ans.begin(),ans.end());
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    init();

    /*pair<int, int> p2=mL*make_pair(0,-1);
    cerr<<"  "<<p2.first<<" "<<p2.second<<endl;*/

    solve();
    cin>>k;
    output();

    return 0;
}
