#include <iostream>
#include <cstdint>
#include <algorithm>
#include <vector> /// Shefa <3
#include <utility>

const uint32_t INF = 1e8;

struct Vector { ///Oshte vednuv Shefa <3
	int64_t x, y;
	Vector(int64_t pX = 0, int64_t pY = 0): x(pX), y(pY) {}
	friend Vector operator+ (const Vector &a, const Vector &b) {
		return Vector(a.x + b.x, a.y + b.y);
	}
	friend Vector operator- (const Vector &a, const Vector &b) {
		return Vector(a.x - b.x, a.y - b.y);
	}
	friend int64_t operator^ (const Vector &a, const Vector &b) {
		return a.x * b.y - a.y * b.x;
	}
};

struct Point {
	Vector p;
	uint32_t ind;
	bool t;
};

std::vector<Point> points;
Point base;

bool point_cmp(const Point &a, const Point &b) {
	Vector av = a.p - base.p;
	Vector bv = b.p - base.p;
	return (av ^ bv) > 0;
}

void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t n;
	std::cin >> n;
	points.resize(2 * n);
	for (uint32_t i = 0;i < 2 * n;i++) {
		std::cin >> points[i].p.x >> points[i].p.y;
		points[i].ind = i + 1;
		points[i].t = i >= n;
	}
}

void prepare() {
	base.p = Vector(INF, INF);
	for (const Point &p : points) {
		if ((p.p.y < base.p.y) || ((p.p.y == base.p.y) && (p.p.x < base.p.x))) {
			base = p;
		}
	}
	points.erase(points.begin() + (base.ind- 1));
	std::sort(points.begin(), points.end(), point_cmp);
}

std::vector<std::pair<uint32_t, uint32_t>> ans;

void calc_ans() {
	Point curOpp;
	for (Point &p : points) {
		if (p.t != base.t) {
			curOpp = p;
			break;
		}
	}
	for (Point &p : points) {
		if (p.t != base.t) {
			ans.push_back({base.ind, p.ind});
			curOpp = p;
		} else {
			ans.push_back({curOpp.ind, p.ind});
		}
	}
}

void print_ans() {
	std::cout << ans.size() << "\n";
	for (auto &i : ans) {
		std::cout << i.first << " " << i.second << "\n";
	}
}

int main() {
	input();
	prepare();
	calc_ans();
	print_ans();
}
