#include <iostream>
#include <cstdint>

const uint32_t MOD = 1e9 + 7;
const uint32_t MAX_N = 1e6 + 12;

uint32_t perm[MAX_N];
uint32_t n;

void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;
	for (uint32_t i = 0;i < n;i++) {
		std::cin >> perm[i];
		perm[i] --;
	}
}

uint64_t fact(uint32_t a) {
	return a == 0 ? 1 : fact(a - 1) * a % MOD;
}

bool vis[MAX_N];

uint32_t loop_len(uint32_t a) {
	if (vis[a]) {
		return 0;
	}
	vis[a] = true;
	return loop_len(perm[a]) + 1;
}

uint32_t loop_cnt[MAX_N];

void calc_loop_cnt() {
	for (uint32_t i = 0;i < n;i++) {
		if (!vis[i]) {
			loop_cnt[loop_len(i)]++;
		}
	}
}

uint64_t wrong_ans() {
	uint64_t ans = 1;
	for (uint32_t i = 1;i <= n;i++) {
		for (uint32_t j = 0;j < loop_cnt[i];j++) {
			ans = ans * i % MOD;
			ans = ans * (j + 1) % MOD;
		}
	}
	return ans;
}

int main() {
	input();
	calc_loop_cnt();
	std::cout << wrong_ans() << "\n";
}

