#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 1e5 + 5;

int32_t n;
unordered_map< int32_t, bool > isBlack[MAX_N];
set< pair< int32_t, int32_t > > blackCells;

void MakeMove(string &currState, char currMove) {
	if(currState == "N") {
		currState[0] = currMove;
	}
	else if(currState == "R") {
		if(currMove == 'R') {
			currState = "Q";
		}
		else if(currMove == 'L') {
			currState = "N";
		}
		else {
			currState = "L";
		}
	}
	else if(currState == "L") {
		if(currMove == 'R') {
			currState = "N";
		}
		else if(currMove == 'L') {
			currState = "Q";
		}
		else {
			currState = "R";
		}
	}
	else if(currState == "Q") {
		if(currMove == 'R') {
			currState = "L";
		}
		else if(currMove == 'L') {
			currState = "R";
		}
		else {
			currState = "N";
		}
	}
	else if(currState == "H") {
		if(currMove == 'H') {
			currState = "N";
		}
		else {
			currState = "HV";
		}
	}
	else if(currState == "V") {
		if(currMove == 'H') {
			currState = "HV";
		}
		else {
			currState = "N";
		}
	}
	else {
        if(currMove == 'H') {
            currState = "V";
        }
        else {
            currState = "H";
        }
	}
}

pair< int32_t, int32_t > GetCell(const string &currState, int32_t r, int32_t c) {
	if(currState == "N") {
		return { r, c };
	}
	else if(currState == "R") {
		return { n - c + 1, r };
	}
	else if(currState == "L") {
		return { c, n - r + 1 };
	}
	else if(currState == "Q" || currState == "HV") {
		return { n - r + 1, n - c + 1 };
	}
	else if(currState == "H") {
		return { r, n - c + 1 };
	}
	else if(currState == "V") {
		return { n - r + 1, c };
	}
}

pair< int32_t, int32_t > Encode(const string &currState, pair< int32_t, int32_t > cell) {
	int32_t r = cell.first, c = cell.second;

	if(currState == "N") {
		return { r, c };
	}
	else if(currState == "L") {
		return { n - c + 1, r };
	}
	else if(currState == "R") {
		return { c, n - r + 1 };
	}
	else if(currState == "Q" || currState == "HV") {
		return { n - r + 1, n - c + 1 };
	}
	else if(currState == "H") {
		return { r, n - c + 1 };
	}
	else if(currState == "V") {
		return { n - r + 1, c };
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t t, m;
	cin >> n >> t >> m;

	for(int32_t i = 1; i <= t; i++) {
		int32_t r, c;
		cin >> r >> c;

		isBlack[r][c] = true;
		blackCells.insert({ r, c });
	}

	string currState = "N";
	for(int32_t i = 1; i <= m; i++) {
		int32_t type;
		cin >> type;

		if(type == 1) {
			char currMove;
			cin >> currMove;

			MakeMove(currState, currMove);
		}
		else {
			int32_t r, c;
			cin >> r >> c;

			pair< int32_t, int32_t > cell = GetCell(currState, r, c);

			if(isBlack[cell.first][cell.second]) {
				isBlack[cell.first][cell.second] = false;
				blackCells.erase(cell);
			}
			else {
				isBlack[cell.first][cell.second] = true;
				blackCells.insert(cell);
			}
		}
	}

	vector< pair< int32_t, int32_t > > allBlackCells;
	for(auto c : blackCells) {
		allBlackCells.push_back(Encode(currState, c));
	}

	sort(allBlackCells.begin(), allBlackCells.end());

	int32_t k;
	cin >> k;
	for(int32_t i = 0; i < k; i++) {
		cout << allBlackCells[i].first << " " << allBlackCells[i].second << endl;
	}

	return 0;
}
