/**
3 3 6
1 1
3 2
3 3
1 R
1 H
2 2 1
1 V
2 1 3
1 H
3
*/

#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 1e5 + 5;

int32_t n;
unordered_map< int32_t, bool > isBlack[MAX_N];
unordered_map< string, string > transformations;
set< pair< int32_t, int32_t > > blackCells;

void InitTransformations() {
    transformations["LL"] = "Q";
    transformations["RR"] = "Q";
    transformations["LQ"] = "R";
    transformations["QL"] = "R";
    transformations["RQ"] = "L";
    transformations["QR"] = "L";
    transformations["VQ"] = "H";
    transformations["QV"] = "H";
    transformations["HQ"] = "V";
    transformations["QH"] = "V";
    transformations["VH"] = "Q";
    transformations["HV"] = "Q";
}

void MakeMove(string &currState, char currMove) {
    if(currMove == 'H' || currMove == 'V') {
        currState += currMove;
        /**
        if(currState.find('H') == string::npos && currState.find('V') == string::npos) {
            currState += currMove;
        }
        else {
            for(int32_t i = currState.size() - 1; i >= 0; i--) {
                if(currState[i] == 'H' || currState[i] == 'V') {
                    currState.erase(i, 1);
                    break;
                }

                if(currState[i] == 'L') {
                    currState[i] = 'R';
                }
                else {
                    currState[i] = 'L';
                }
            }
        }

        if(currState.size() == 0) {
            currState = "Q";
        }
        */
    }
    else {
        currState += currMove;
    }

    /**
    while(1) {
        if(currState.size() > 1) {
            string lastTwo = currState.substr(currState.size() - 2);
            if(transformations.count(lastTwo) != 0) {
                currState.erase(currState.size() - 2);
                currState += transformations[lastTwo];
            }
            else {
                break;
            }
        }
        else {
            break;
        }
    }
    */
}

pair< int32_t, int32_t > GetCell(const string &currState, int32_t r, int32_t c) {
    int32_t r1, c1;

    for(auto ch : currState) {
        if(ch == 'L') {
            r1 = n - c + 1;
            c1 = r;
        }
        else if(ch == 'R') {
            r1 = c;
            c1 = n - r + 1;
        }
        else if(ch == 'Q') {
            r1 = n - r + 1;
            c1 = n - c + 1;
        }
        else if(ch == 'H') {
            r1 = r;
            c1 = n - c + 1;
        }
        else if(ch == 'V') {
            r1 = n - r + 1;
            c1 = c;
        }

        r = r1;
        c = c1;
    }

    return { r, c };
}

pair< int32_t, int32_t > Encode(const string &currState, pair< int32_t, int32_t > cell) {
    int32_t r = cell.first, c = cell.second;
    int32_t r1, c1;

    for(auto ch : currState) {
        if(ch == 'L') {
            r1 = c;
            c1 = n - r + 1;
        }
        else if(ch == 'R') {
            r1 = n - c + 1;
            c1 = r;
        }
        else if(ch == 'Q') {
            r1 = n - r + 1;
            c1 = n - c + 1;
        }
        else if(ch == 'V') {
            r1 = n - r + 1;
            c1 = c;
        }
        else if(ch == 'H') {
            r1 = r;
            c1 = n - c + 1;
        }

        r = r1;
        c = c1;
    }

    return { r, c };
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

    InitTransformations();

	int32_t t, m;
	cin >> n >> t >> m;

	for(int32_t i = 1; i <= t; i++) {
		int32_t r, c;
		cin >> r >> c;

		isBlack[r][c] = true;
		blackCells.insert({ r, c });
	}

	string currState = "";
	for(int32_t i = 1; i <= m; i++) {
		int32_t type;
		cin >> type;

		if(type == 1) {
			char currMove;
			cin >> currMove;

            //cout << currState << " + " << currMove << " -> ";
			MakeMove(currState, currMove);
            //cout << currState << endl;
		}
		else {
			int32_t r, c;
			cin >> r >> c;

			pair< int32_t, int32_t > cell = GetCell(currState, r, c);

			//cout << r << " " << c << " " << currState << " -> " << cell.first << " " << cell.second << endl;

			if(isBlack[cell.first][cell.second]) {
				isBlack[cell.first][cell.second] = false;
				blackCells.erase(cell);
			}
			else {
				isBlack[cell.first][cell.second] = true;
				blackCells.insert(cell);
			}
		}
	}

	vector< pair< int32_t, int32_t > > allBlackCells;
	for(auto c : blackCells) {
		allBlackCells.push_back(Encode(currState, c));
	}

	sort(allBlackCells.begin(), allBlackCells.end());

	int32_t k;
	cin >> k;
	for(int32_t i = 0; i < k; i++) {
		cout << allBlackCells[i].first << " " << allBlackCells[i].second << endl;
	}

	return 0;
}
